import { OnModuleDestroy } from '@nestjs/common';
import Redis, { Cluster, RedisOptions } from 'ioredis';
import { ThrottlerStorageRedis } from './throttler-storage-redis.interface';
export declare class ThrottlerStorageRedisService implements ThrottlerStorageRedis, OnModuleDestroy {
    redis: Redis | Cluster;
    disconnectRequired?: boolean;
    constructor(redis?: Redis);
    constructor(cluster?: Cluster);
    constructor(options?: RedisOptions);
    constructor(url?: string);
    getRecord(key: string): Promise<number[]>;
    addRecord(key: string, ttl: number): Promise<void>;
    onModuleDestroy(): void;
}
