"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ThrottlerStorageRedisService = void 0;
const common_1 = require("@nestjs/common");
const ioredis_1 = require("ioredis");
let ThrottlerStorageRedisService = class ThrottlerStorageRedisService {
    constructor(redisOrOptions) {
        if (redisOrOptions instanceof ioredis_1.default || redisOrOptions instanceof ioredis_1.Cluster) {
            this.redis = redisOrOptions;
        }
        else if (typeof redisOrOptions === 'string') {
            this.redis = new ioredis_1.default(redisOrOptions);
        }
        else {
            this.redis = new ioredis_1.default(redisOrOptions);
        }
    }
    async getRecord(key) {
        const setMembers = await this.redis.smembers(key);
        const now = Date.now();
        const expiredMembers = setMembers.filter((m) => parseInt(m) < now);
        if (expiredMembers.length) {
            await this.redis.srem(key, expiredMembers);
        }
        return setMembers
            .filter((m) => parseInt(m) > now)
            .map((m) => parseInt(m))
            .sort();
    }
    async addRecord(key, ttl) {
        const multi = this.redis.multi();
        multi.sadd(key, Date.now() + ttl * 1000);
        multi.expire(key, ttl);
        await multi.exec();
    }
    onModuleDestroy() {
        var _a;
        if (this.disconnectRequired) {
            (_a = this.redis) === null || _a === void 0 ? void 0 : _a.disconnect(false);
        }
    }
};
ThrottlerStorageRedisService = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [Object])
], ThrottlerStorageRedisService);
exports.ThrottlerStorageRedisService = ThrottlerStorageRedisService;
//# sourceMappingURL=throttler-storage-redis.service.js.map